/*  "PostScript BASIC n!" for "Trigram" (Subroutines for Trigram)
 *  Copyright (C) 1999 YOSHIDA Daisuke.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif


#include<stdio.h>
#include<gtk/gtk.h>
#include"gladesig.h"
#include"gladesrc.h"
#include"psbasicn.h"

gfloat LINEWIDTH;
gfloat GRAPH_MAG = 20;
gint AREA_PLOT = FALSE;
gfloat XXX[3], YYY[3];
gfloat XX[2], YY[2];

void psbn_line(FILE *ps_file, gfloat x1, gfloat y1, gfloat x2, gfloat y2)
{
  /*
   * line (x1,y1)-(x2,y2)
   */
  fprintf (ps_file, "%% line(%f,%f)-(%f,%f)\n", x1, y1, x2, y2);
  fprintf (ps_file, "newpath\n");
  fprintf (ps_file, " %f %f moveto\n", x1, y1);
  fprintf (ps_file, " %f %f lineto\n", x2, y2);
  fprintf (ps_file, " %f setlinewidth stroke\n\n", LINEWIDTH);
}

void psbn_linewidth (gfloat n)
{
  /*
   * 
   */
  LINEWIDTH = n;
}

void psbn_circle (FILE *ps_file, gfloat x1, gfloat y1, gfloat cr_size)
{
  /*
   * (x1, y1)濴ˤľcr_sizeαߤ
   */
  gfloat sz;
  sz=cr_size/2;

  fprintf (ps_file, "%% Circle (%f, %f), %f\nnewpath\n", x1, y1, sz);
  fprintf (ps_file, " %f %f %f 0 360 arc\n", x1, y1, sz);
  fprintf (ps_file, " %f setlinewidth stroke\n\n", LINEWIDTH);
}

void psbn_circle_fill (FILE *ps_file, gfloat x1, gfloat y1, gfloat cr_size)
{
  /*
   * (x1, y1)濴ˤľcr_sizeαߤɤĤ֤
   */
  gfloat sz;
  sz=cr_size/2;

  fprintf (ps_file, "%% Circle (%f, %f), %f, fill\nnewpath\n",
	   x1, y1, sz);
  fprintf (ps_file, " %f %f %f 0 360 arc\n", x1, y1, sz);
  fprintf (ps_file, " %f setlinewidth fill\n\n", LINEWIDTH);
}

void psbn_box (FILE *ps_file, gfloat x1, gfloat y1, gfloat bx_size)
{
  /*
   * (x1, y1)濴ˤưդĹbx_sizeλͳѷ
   */
  gfloat fx1, fy1;
  fx1 = x1-(bx_size/2);
  fy1 = y1-(bx_size/2);

  fprintf (ps_file, "%% Box (%f, %f), %f\n", x1, y1, bx_size);
  fprintf (ps_file, "newpath\n");
  fprintf (ps_file, " %f %f moveto\n", fx1, fy1);
  fprintf (ps_file, " %f 0 rlineto 0 %f rlineto\n", bx_size, bx_size);
  fprintf (ps_file, " %f 0 rlineto closepath\n", -bx_size);
  fprintf (ps_file, " %f setlinewidth stroke\n\n", LINEWIDTH);
}

void psbn_box_fill (FILE *ps_file, gfloat x1, gfloat y1, gfloat bx_size)
{
  /*
   * (x1, y1)濴ˤưդĹbx_sizeιͳѷ
   */
  gfloat fx1, fy1;
  fx1 = x1-(bx_size/2);
  fy1 = y1-(bx_size/2);

  fprintf (ps_file, "%% BoxFill (%f, %f), %f\n", x1, y1, bx_size);
  fprintf (ps_file, "newpath\n");
  fprintf (ps_file, " %f %f moveto\n", fx1, fy1);
  fprintf (ps_file, " %f 0 rlineto 0 %f rlineto\n", bx_size, bx_size);
  fprintf (ps_file, " %f 0 rlineto closepath\n", -bx_size);
  fprintf (ps_file, " %f setlinewidth fill\n\n", LINEWIDTH);
}

void psbn_X (FILE *ps_file, gfloat x1, gfloat y1, gfloat cr_size)
{
  /*
   * (x1, y1)濴ˤưդĹcr_sizeX
   */
  gfloat fx1, fy1, fx2, fy2;
  fx1 = x1 - cr_size * 0.5; fx2 = fx1 + cr_size;
  fy1 = y1 - cr_size * 0.5; fy2 = fy1 + cr_size;

  fprintf (ps_file, "%% X (%f, %f), %f\n", x1, y1, cr_size);
  fprintf (ps_file, "newpath\n");
  fprintf (ps_file, " %f %f moveto\n", fx1, fy1);
  fprintf (ps_file, " %f %f lineto\n", fx2, fy2);
  fprintf (ps_file, " %f %f moveto\n", fx1, fy2);
  fprintf (ps_file, " %f %f lineto\n", fx2, fy1);
  fprintf (ps_file, " %f setlinewidth stroke\n\n", LINEWIDTH);
}

void psbn_triangle (FILE *ps_file, gfloat x1, gfloat y1, gfloat tr_size)
{
  /*
   * (x1, y1)濴ˤưդĹtr_sizeλѷ
   */
  gfloat fx1, fy1;
  gfloat rx1, ry1;
  rx1 = tr_size * -0.5;
  ry1 = rx1 * -1.7320508;
  fx1 = x1 + rx1;
  fy1 = y1 - ry1 * 0.333333333;

  fprintf (ps_file, "%% Triangle (%f, %f), %f\n", x1, y1, tr_size);
  fprintf (ps_file, "newpath\n");
  fprintf (ps_file, " %f %f moveto\n", fx1, fy1);
  fprintf (ps_file, " %f 0 rlineto\n", tr_size);
  fprintf (ps_file, " %f %f rlineto\n", rx1, ry1);
  fprintf (ps_file, "closepath %f setlinewidth stroke\n\n", LINEWIDTH);
}

void psbn_cross (FILE *ps_file, gfloat x1, gfloat y1, gfloat sz)
{
  /*
   * (x1, y1)  
   */

  fprintf (ps_file,
	   "%% Cross (%f, %f), %f\n"
	   "newpath\n"
	   " %f %f moveto %f 0 rlineto\n"
	   " %f %f moveto 0 %f rlineto\n"
	   " %f setlinewidth stroke\n\n"
	   , x1, y1, sz, x1-sz/2, y1, sz, x1, y1-sz/2, sz, LINEWIDTH);
}

void psbn_plot(FILE *ps_file, gfloat x, gfloat y, gfloat z, gint tp)
{
  /*
   * (x, y, z)˥tpΥץåȤ򤹤
   */
  gfloat x1, y1;
  gfloat xx, yy, zz, ww;

  ww=x+y+z;
  xx=x/ww; yy=y/ww; zz=z/ww;
  x1=xx*XXX[0]+yy*XXX[1]+zz*XXX[2];
  y1=xx*YYY[0]+yy*YYY[1]+zz*YYY[2];

  switch (tp) {
  case 0:
    psbn_circle (ps_file, x1, y1, GRAPH_MAG);
    break;
  case 1:
    psbn_box (ps_file, x1, y1, GRAPH_MAG);
    break;
  case 2:
    psbn_X (ps_file, x1, y1, GRAPH_MAG);
    break;
  case 3:
    psbn_box_fill (ps_file, x1, y1, GRAPH_MAG);
    break;
  case 4:
    psbn_cross (ps_file, x1, y1, GRAPH_MAG);
    break;
  case 5:
    psbn_triangle (ps_file, x1, y1, GRAPH_MAG);
    break;
  case 6:
    psbn_circle_fill (ps_file, x1, y1, GRAPH_MAG);
    break;
  default:
    break;
  }
}

FILE *psbn_open(gchar *filename,
		gchar *X_LABEL, gchar *Y_LABEL, gchar *Z_LABEL,
		gint LINE_DIFF, gint NUM_DIFF)
{
  /*
   * PostScriptե򥪡ץ󤷤ƽ򤹤
   */
  FILE *open_file;
  open_file = fopen (filename, "w");
  psbn_open_fd (open_file, X_LABEL, Y_LABEL,
		Z_LABEL, LINE_DIFF, NUM_DIFF);
  return open_file;
}

void psbn_open_fd (FILE *open_file,
		   gchar *X_LABEL, gchar *Y_LABEL, gchar *Z_LABEL,
		   gint LINE_DIFF, gint NUM_DIFF)
{
  /*
   * եǥץν򤹤
   */
  gfloat fx1, fy1;
  gfloat rx1, ry1;
  gint i;
  gchar *lbl;

  fprintf (open_file, "%%!PS-Adobe-3.0 EPSF-3.0\n");
  fprintf (open_file, "%%%%Title: Trigram %s output\n", VERSION);
  fprintf (open_file, "%%%%Creator: Trigram(gtk) ver %s\n", VERSION);
  fprintf (open_file,
	   "%%%%BoundingBox: 0 0 1000 1000\n\n"
	   "%%%%EndComments\n");

  /* Ȥ */
  if (AREA_PLOT == FALSE) {
    XXX[0]=500; XXX[1]=100; XXX[2]=900;
    YYY[0]=792.82032; YYY[1]=100; YYY[2]=100;
  }

  fx1 = (XXX[0]+XXX[1]+XXX[2])/3;
  fy1 = (YYY[0]+YYY[1]+YYY[2])/3;
  rx1 = XXX[2]-XXX[1];
  GRAPH_MAG=20;

  psbn_linewidth (GRAPH_MAG*0.2);
  psbn_triangle (open_file, fx1, fy1, rx1);

  /*  */
  psbn_linewidth (GRAPH_MAG*0.05);
  for (i=0; i<100; i+=LINE_DIFF) {
    if (i==0)
      continue;

    fx1=(100-i)*0.01*XXX[0]+i*0.01*XXX[1];
    fy1=(100-i)*0.01*YYY[0]+i*0.01*YYY[1];
    rx1=(100-i)*0.01*XXX[2]+i*0.01*XXX[1];
    ry1=(100-i)*0.01*YYY[2]+i*0.01*YYY[1];
    psbn_line (open_file, fx1, fy1, rx1, ry1);

    fx1=(100-i)*0.01*XXX[1]+i*0.01*XXX[2];
    fy1=(100-i)*0.01*YYY[1]+i*0.01*YYY[2];
    rx1=(100-i)*0.01*XXX[0]+i*0.01*XXX[2];
    ry1=(100-i)*0.01*YYY[0]+i*0.01*YYY[2];
    psbn_line (open_file, fx1, fy1, rx1, ry1);

    fx1=(100-i)*0.01*XXX[2]+i*0.01*XXX[0];
    fy1=(100-i)*0.01*YYY[2]+i*0.01*YYY[0];
    rx1=(100-i)*0.01*XXX[1]+i*0.01*XXX[0];
    ry1=(100-i)*0.01*YYY[1]+i*0.01*YYY[0];
    psbn_line (open_file, fx1, fy1, rx1, ry1);
  }

  /* ͤ */
  lbl=g_malloc(10);

  for (i=0; i<100; i+=NUM_DIFF) {
    if (i==0) {
      if (AREA_PLOT == FALSE) {
	psbn_string (open_file, XXX[0]-GRAPH_MAG*0.75*strlen(X_LABEL),
		     YYY[0]+GRAPH_MAG*0.75,
		     X_LABEL, GRAPH_MAG*2.5);
	psbn_string (open_file, 40, YYY[1]-GRAPH_MAG*1.75,
		     Y_LABEL, GRAPH_MAG*2.5);
	psbn_string (open_file, 960-GRAPH_MAG*1.5*strlen(Z_LABEL),
		     YYY[2]-GRAPH_MAG*1.75,
		     Z_LABEL, GRAPH_MAG*2.5);
      }
      continue;
    }
    sprintf (lbl, "%d", 100-i);

    fx1=(100-i)*0.01*XXX[0]+i*0.01*XXX[1];
    fy1=(100-i)*0.01*YYY[0]+i*0.01*YYY[1];
    if (fx1>GRAPH_MAG*1.5 && fx1<1000-GRAPH_MAG*1.5 &&
	fy1>GRAPH_MAG*1.5 && fy1<1000-GRAPH_MAG*1.5)
      psbn_string (open_file, fx1-GRAPH_MAG*1.3, fy1, lbl, GRAPH_MAG);

    fx1=(100-i)*0.01*XXX[1]+i*0.01*XXX[2];
    fy1=(100-i)*0.01*YYY[1]+i*0.01*YYY[2];
    if (fx1>GRAPH_MAG*1.5 && fx1<1000-GRAPH_MAG*1.5 &&
	fy1>GRAPH_MAG*1.5 && fy1<1000-GRAPH_MAG*1.5)
      psbn_string (open_file, fx1-GRAPH_MAG*0.6,
		   fy1-GRAPH_MAG, lbl, GRAPH_MAG);

    fx1=(100-i)*0.01*XXX[2]+i*0.01*XXX[0];
    fy1=(100-i)*0.01*YYY[2]+i*0.01*YYY[0];
    if (fx1>GRAPH_MAG*1.5 && fx1<1000-GRAPH_MAG*1.5 &&
	fy1>GRAPH_MAG*1.5 && fy1<1000-GRAPH_MAG*1.5)
      psbn_string (open_file, fx1-GRAPH_MAG*0.1,
		   fy1+GRAPH_MAG*0.5, lbl, GRAPH_MAG);
  }

  psbn_linewidth (GRAPH_MAG*0.1);
  g_free(lbl);
  AREA_PLOT=FALSE;
}

void psbn_close (FILE *ps_file)
{
  /*
   * PostScriptեĤ
   */
  fprintf (ps_file, "showpage\n");
  fprintf (ps_file, "%%%%EOF\n");
  fclose (ps_file);
}

void psbn_pshead (FILE *ps_file,
		  gchar *X_LABEL, gchar *Y_LABEL, gchar *Z_LABEL,
		  gint LINE_DIFF, gint NUM_DIFF)
{
  /*
   * PostScriptեΥإå񤭽Ф
   */
  fprintf (ps_file, "%%!PS-Adobe-3.0\n");
  fprintf (ps_file, "%%%%Creator: Trigram ver %s\n", VERSION);
  fprintf (ps_file, "%%%%Title: Trigram %s output\n", VERSION);
  fprintf (ps_file,
	   "%%%%Pages: 2\n"
	   "%%%%DocumentFonts: Courier-Bold\n"
	   "%%%%DocumentNeededFonts: Courier-Bold\n"
	   "%%%%DocumentPaperSizes: A4\n"
	   "%%%%Orientation: Portrait\n"
	   "%%%%EndComments\n"
	   "%%%%BeginProlog\n"
	   "/BeginEPSF {%%def\n"
	   " /b4_lnc_state save def\n"
	   " /dict_count countdictstack def\n"
	   " /op_count count 1 sub def\n"
	   " userdict begin\n"
	   " /showpage {} def\n"
	   " 0 setgray 0 setlinecap\n"
	   " 1 setlinewidth 0 setlinejoin\n"
	   " 10 setmiterlimit [] 0 setdash\n"
	   " newpath\n"
	   " /languagelevel where\n"
	   " {pop languagelevel\n"
	   "   1 ne\n"
	   "   {false setstrokeadjust\n"
	   "   false setoverprint\n"
	   "   }if\n"
	   " } if\n"
	   "}bind def\n"
	   "/EndEPSF {%%def\n"
	   " count op_count sub\n"
	   " {pop} repeat\n"
	   " countdictstack dict_count sub\n"
	   " {end} repeat\n"
	   " b4_lnc_state restore\n"
	   "}bind def\n"
	   "/rect {%% llx lly w h\n"
	   " 4 2 roll moveto 1 index 0 rlineto 0 exch rlineto\n"
	   " neg 0 rlineto closepath\n"
	   "}bind def\n"
	   "%%%%EndProlog\n"
	   "%%%%BeginSetup\n"
	   "%%%%IncludeFont: Courier-Bold\n"
	   "%%%%EndSetup\n"
	   "%%%%Page: 1 1\n"
	   "%%%%BeginPageSetup\n"
	   "/pgsave save def\n"
	   "%%%%EndPageSetup\n"
	   "BeginEPSF\n"
	   " 75 200 translate 0.45 0.45 scale\n"
	   " 0 0 1000 1000 rect clip newpath\n"
	   "%%%%BeginDocument: trigramdata.eps\n");
  psbn_open_fd(ps_file, X_LABEL, Y_LABEL,
	       Z_LABEL, LINE_DIFF, NUM_DIFF);
  return;
}

void psbn_psnewpage (FILE *ps_file)
{
  /*
   * Ǥ
   */

  gfloat x1, x2, y1, y2, x, y, sz;
  x1=XX[0]*360+120 ; x2=XX[1]*360+120;
  y1=YY[0]*360+245; y2=YY[1]*360+245;
  x=(x1+x2)/2; y=(y1+y2)/2; sz=(x2-x1)*1.25;

  fprintf (ps_file,
	   "showpage\n"
	   "%%%%EOF\n"
	   "%%%%EndDocument\n"
	   "EndEPSF\n");
  psbn_linewidth(GRAPH_MAG*0.1);
  psbn_box (ps_file, x, y, sz);
  fprintf (ps_file,
	   "pgsave restore showpage\n"
	   "%%%%Page: 2 2\n"
	   "%%%%BeginPageSetup\n"
	   "/pgsave save def\n"
	   "%%%%EndPageSetup\n"
	   "BeginEPSF\n"
	   " 75 200 translate 0.45 0.45 scale\n"
	   " 0 0 1000 1000 rect clip newpath\n"
	   "%%%%BeginDocument: trigramdata2.eps\n");
}	   

void psbn_pstail(FILE *ps_file)
{
  /*
   * PostScriptο񤭽Ф
   */
  fprintf (ps_file,
	   "showpage\n"
	   "%%%%EOF\n"
	   "%%%%EndDocument\n"
	   "EndEPSF\n"
	   "pgsave restore showpage\n"
	   "%%%%EOF\n");
}

void psbn_string (FILE *ps_file, gfloat x1, gfloat y1, gchar *str, gfloat sz)
{
  /*
   * ʸ str ɽ
   */
  fprintf (ps_file,
	   "%% String (%f, %f, \"%s\"), %f\n"
	   "/Courier-Bold findfont %f scalefont setfont\n"
	   " %f %f moveto (%s)\n"
	   "show\n\n", x1, y1, str, sz, sz, x1, y1, str);
}

void psbn_plotarea_init()
{
  /*
   * ΰץåȻγΰη׻򳫻Ϥ
   */
  XX[1] = YY[1] = -1;
  XX[0] = YY[0] = 2;
}

void psbn_plotarea_data (gfloat x1, gfloat y1, gfloat z1)
{
  /* 
   * ΰץåȻ˻ȤǡͿ
   */
  
  gfloat xx, yy, x, y, z, w;
  w=x1+y1+z1;
  if (w==0) return;
  x=x1/w; y=y1/w; z=z1/w;

  xx = x*0.5 + z;
  yy = x*0.8660254;

  if (XX[0]>xx) XX[0]=xx;
  if (XX[1]<xx) XX[1]=xx;
  if (YY[0]>yy) YY[0]=yy;
  if (YY[1]<yy) YY[1]=yy;
}

void psbn_plotarea_depend ()
{
  /*
   * ΰץåȻΰꤹ
   * šŤĤޤ( XXX, YYY)
   */

  gfloat rr, rx, ry;

  rx=XX[1]-XX[0]; ry=YY[1]-YY[0];
  if (rx<0 || ry<0) {
    AREA_PLOT=FALSE;
    return;
  }

  AREA_PLOT=TRUE;
  if (rx<ry) {
    rr=ry-rx; 
    XX[1] += rr/2;
    XX[0] -= rr/2;
  } else {
    rr=rx-ry; 
    YY[1] += rr/2;
    YY[0] -= rr/2;
  }

  rr=800/(XX[1]-XX[0]);
  XXX[1]=-XX[0]*rr+100; XXX[2]=(1-XX[0])*rr+100; XXX[0]=(XXX[1]+XXX[2])/2;
  YYY[1]=-YY[0]*rr+100; YYY[2]=YYY[1]; YYY[0]=(0.8660254-YY[0])*rr+100;
}
